#include <amxmodx>
#include <amxmisc>
#include <ColorChat>
#include <fakemeta>
#include <engine>
#include <hamsandwich>
#include <fun>
#include <cs_weap_models_api>
#include <zp50_core>
#include <zp50_class_zombie>
#include <zp50_class_nemesis>
#include <zp50_class_survivor>
#include <zombieplague>

#define TASK_INVISIBLE 124798
#define TASK_COOLDOWN 574825

new g_zclass_light 
new bool:can_invisible[33] 
new bool:is_invisible[33] 

new const zombieclass1_name[] = "ZOMBIE_GHOST"
new const zombieclass1_info[] = "ZOMBIE_GHOST_INFO"
new const zombieclass1_models[] = { "zm_ghost" }
new const zombieclass1_clawmodels[][] = { "models/zombie_mod/zombie/ghost/v_claw_ghost_zombie.mdl" }
new const zombieclass2_clawmodels[] = "models/zombie_mod/zombie/ghost/v_claw_ghost_zombie.mdl"
new const zombieclass1_invis_claw[] = "models/zombie_mod/zombie/ghost/v_claw_invis_ghost.mdl"
new const infect_ghost_sound[] = "zombie_mod/zombie/zombi_female_scream.wav" 
new const pain_ghost_sound[] = "zombie_mod/zombie/zombi_hurt_female_1.wav" 
new const pain_ghost_sound2[] = "zombie_mod/zombie/zombi_hurt_female_2.wav" 
new const death_ghost_sound[] = "zombie_mod/zombie/zombi_death_female_1.wav"
const zombieclass1_health = 3000
const Float:zombieclass1_speed = 0.75
const Float:zombieclass1_gravity = 1.0
const Float:zombieclass1_knockback = 1.0

new cvar_inv_time
new cvar_cooldown
new cvar_invisible_amount

new const invisible_sound[] = "zombie_mod/zombie/ghost/zombi_pressure_female.wav"

public plugin_init()
{
	register_clcmd("drop", "use_skill")
	RegisterHam(Ham_TakeDamage, "player", "CPlayer__TakeDamage")
	register_forward(FM_EmitSound, "fw_EmitSound")
	
	cvar_inv_time = register_cvar("zp_zclass_light_invisible_time", "10.0")
	cvar_cooldown = register_cvar("zp_zclass_light_cooldown", "30.0")
	cvar_invisible_amount = register_cvar("zp_zclass_light_invisible_amount", "50")
}

public plugin_precache()
{
	new index
	
	g_zclass_light = zp_class_zombie_register(zombieclass1_name, zombieclass1_info, zombieclass1_health, zombieclass1_speed, zombieclass1_gravity)
	zp_class_zombie_register_kb(g_zclass_light, zombieclass1_knockback)
	for (index = 0; index < sizeof zombieclass1_models; index++)
		zp_class_zombie_register_model(g_zclass_light, zombieclass1_models[index])
	for (index = 0; index < sizeof zombieclass1_clawmodels; index++)
		zp_class_zombie_register_claw(g_zclass_light, zombieclass1_clawmodels[index])
		
	precache_sound(pain_ghost_sound[0])
	precache_sound(pain_ghost_sound2[0])
	precache_sound(infect_ghost_sound[0])
	precache_sound(death_ghost_sound[0])
		
	precache_sound(invisible_sound)
	precache_model(zombieclass1_invis_claw)
	precache_model("models/zombie_mod/zombie/ghost/v_claw_ghost_jumpbomb.mdl")
}

public zp_user_infected_post(id, infector)
{
	if(zp_core_is_zombie(id) && zp_class_zombie_get_current(id) == g_zclass_light && !zp_class_nemesis_get(id))
	{
		can_invisible[id] = true
		is_invisible[id] = false
		remove_task(id+TASK_INVISIBLE)
		remove_task(id+TASK_COOLDOWN)
		
		emit_sound(id, CHAN_VOICE, infect_ghost_sound,  VOL_NORM, ATTN_NORM, 0, PITCH_NORM)
		
		ColorChat(id, TEAM_COLOR, "^4%L %L", id, "CHAT_PREFIX", id, "CHAT_INFO_GHOST1")
	}
}

public zp_user_humanized_post(id)
{
	can_invisible[id] = false
	is_invisible[id] = false
	
	remove_task(id-TASK_INVISIBLE)
	remove_task(id-TASK_COOLDOWN)
}

public use_skill(id)
{
	if(is_user_alive(id) && zp_core_is_zombie(id) && zp_class_zombie_get_current(id) == g_zclass_light && !zp_class_nemesis_get(id))
	{
		if(can_invisible[id] && !is_invisible[id])
		{
			do_skill(id)	
		} 
		else 
		{
			ColorChat(id, TEAM_COLOR, "^4%L %L", id, "CHAT_PREFIX", id, "CHAT_INFO_GHOST2")
		}
	}
}

public do_skill(id)
{
	cs_set_player_view_model(id, CSW_KNIFE, zombieclass1_invis_claw)
	is_invisible[id] = true
	can_invisible[id] = false

	set_user_maxspeed(id, get_user_maxspeed(id) - 50)
	
	set_user_rendering(id, kRenderFxGlowShell, 0, 0, 0, kRenderTransAlpha, get_pcvar_num(cvar_invisible_amount))

	emit_sound(id, CHAN_VOICE, invisible_sound, 1.0, ATTN_NORM, 0, PITCH_NORM)

	set_task(get_pcvar_float(cvar_inv_time), "visible", id+TASK_INVISIBLE)
	
	ColorChat(id, TEAM_COLOR, "^4%L %L", id, "CHAT_PREFIX", id, "CHAT_INFO_GHOST3")
}

public visible(taskid)
{
	new id = taskid - TASK_INVISIBLE
	
	is_invisible[id] = false
	
	cs_set_player_view_model(id, CSW_KNIFE, zombieclass2_clawmodels)
	set_user_maxspeed(id, get_user_maxspeed(id) + 50)
	set_user_rendering(id, kRenderFxGlowShell, 0, 0, 0, kRenderTransAlpha, 255)
	
	ColorChat(id, TEAM_COLOR, "^4%L %L", id, "CHAT_PREFIX", id, "CHAT_INFO_GHOST4")
	
	set_task(get_pcvar_float(cvar_cooldown), "reset_cooldown", id+TASK_COOLDOWN)
}

public reset_cooldown(taskid)
{
	new id = taskid - TASK_COOLDOWN
	
	can_invisible[id] = true
	
	ColorChat(id, TEAM_COLOR, "^4%L %L", id, "CHAT_PREFIX", id, "CHAT_INFO_GHOST5")
}

public CPlayer__TakeDamage(id, iVictim, iInflictor, iAttacker, Float:flDamage, bitsDamage)
{
	if (zp_class_zombie_get_current(id) == g_zclass_light && zp_core_is_zombie(id) && !zp_class_nemesis_get(id) && !zp_class_survivor_get(id))
	{
		new rand = random_num(1,2)
		switch(rand)
  		{
			case 1: emit_sound(id, CHAN_WEAPON, pain_ghost_sound[0], 1.0, ATTN_NORM, 0, PITCH_LOW)
			case 2: emit_sound(id, CHAN_WEAPON, pain_ghost_sound2[0], 1.0, ATTN_NORM, 0, PITCH_LOW)
		}
	}
} 

public fw_EmitSound(id, channel, const sample[], Float:volume, Float:attn, flags, pitch)
{
	if(!is_user_connected(id))
		return FMRES_HANDLED;	

	if (sample[0] == 'h' && sample[1] == 'o' && sample[2] == 's' && sample[3] == 't' && sample[4] == 'a' && sample[5] == 'g' && sample[6] == 'e')
		return FMRES_SUPERCEDE;


	if (sample[7] == 'd' && ((sample[8] == 'i' && sample[9] == 'e') || (sample[8] == 'e' && sample[9] == 'a')))
	{
		emit_sound(id, channel, death_ghost_sound, volume, attn, flags, pitch)
		return FMRES_SUPERCEDE;
	}
	return FMRES_IGNORED;
}